; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm
      include lineio.inc

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib lineio.lib

      DlgProc   PROTO :DWORD,:DWORD,:DWORD,:DWORD

    ; -----------------------------
    ; macros for displaying results
    ; -----------------------------
      SBtext MACRO part,lpString
        invoke SendMessage,hStatus,SB_SETTEXT,part-1,reparg(lpString)
      ENDM

      TBtext MACRO lpString
        invoke SetWindowText,FUNC(GetActiveWindow),reparg(lpString)
      ENDM

      EDtext MACRO lpString
        invoke SetWindowText,hEdit,reparg(lpString)
      ENDM

      EDclear equ <EDtext 0>

    .data?
        hWnd      dd ?
        hInstance dd ?
        hStatus   dd ?
        hEdit     dd ?

    .code

; 

start: 
    mov hInstance, FUNC(GetModuleHandle,NULL)
    call main
    invoke ExitProcess,eax

; 

main proc

    invoke InitCommonControls

    Dialog "   ", \                         ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            9, \                            ; number of controls
            50,50,250,106, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Run Test",WS_TABSTOP,5, 5,50,13,101
    DlgButton "Unused",WS_TABSTOP,5,20,50,13,102
    DlgButton "Unused",WS_TABSTOP,5,35,50,13,103
    DlgButton "Unused",WS_TABSTOP,5,50,50,13,104
    DlgButton "Unused",WS_TABSTOP,5,65,50,13,105
    DlgButton "Reset",WS_TABSTOP,60,65,50,13,106
    DlgButton "Close",WS_TABSTOP,192,65,50,13,IDCANCEL
    DlgStatus 110
    DlgEdit WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or \
            ES_LEFT or WS_BORDER or WS_VSCROLL,60,5,182,58,111

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

align 4

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL hDC   :DWORD
    LOCAL spos  :DWORD
    LOCAL wpos  :DWORD
    LOCAL rv    :DWORD
    LOCAL pMem  :DWORD
    LOCAL pBuf  :DWORD
    LOCAL flen  :DWORD
    LOCAL pstr1 :DWORD
    LOCAL pstr2 :DWORD
    LOCAL ps    :PAINTSTRUCT 
    LOCAL rct   :RECT 
    LOCAL crct  :RECT 
    LOCAL buffer1[1024]:BYTE 
    LOCAL buffer2[1024]:BYTE 
    LOCAL buffer3[260]:BYTE 
    LOCAL buffer4[260]:BYTE 

    STRING MainTitle,"Test linein$ and lineout$"

    Switch uMsg
      Case WM_INITDIALOG
        m2m hWnd, hWin
        invoke SendMessage,hWnd,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        invoke SetWindowText,hWnd,ADDR MainTitle

        mov hStatus, FUNC(GetDlgItem,hWnd,110)
        GLOBAL sbarray dd 100,200,300,400,-1
        invoke SendMessage,hStatus,SB_SETPARTS,5,ADDR sbarray

        mov hEdit,   FUNC(GetDlgItem,hWnd,111)
        invoke SendMessage,hEdit,WM_SETFONT,
                           FUNC(GetStockObject,ANSI_FIXED_FONT),TRUE
        mov eax, 1

      Case WM_COMMAND
        Switch wParam
          Case 101

          ; ******************************************

            mov pstr1, ptr$(buffer1)
            mov pstr2, ptr$(buffer2)

            mov pMem, InputFile("\masm32\include\windows.inc")

            mov flen, ecx
            add ecx, flen                               ; double ECX
            mov spos, 0
            mov wpos, 0

            mov pBuf, alloc(ecx)                        ; allocate output buffer

            push esi
            xor esi, esi                                ; zero ESI as counter
          ; ------------------------------------------
          @@:
            mov spos, linein$(pMem,pstr1,spos)          ; read line from memory

            mov eax, pstr2
            mov BYTE PTR [eax], 0                       ; reset pstr2 to zero length
            add esi, 1
            mov pstr2, cat$(pstr2,str$(esi),": ",pstr1)
            mov pstr2, rtrim$(pstr2)

            mov wpos, lineout$(pstr2,pBuf,wpos,0)       ; write line to memory

            cmp spos, 0
            jnz @B
          ; ------------------------------------------
            pop esi

            test OutputFile("test.inc",pBuf,wpos), 0

            free pMem
            free pBuf

            mov eax, pstr2
            mov BYTE PTR [eax], 0                       ; reset pstr2 to zero length

            mov pstr2, cat$(pstr2,str$(wpos)," bytes written")

            fn MessageBox,hWnd,pstr2,"test.inc written to disk",MB_OK

          ; ******************************************

          Case 102
            TBtext "ID 102"
            SBtext 2,"Test 2"
            EDtext "The 2nd button was pressed"

          Case 103
            TBtext "ID 103"
            SBtext 3,"Test 3"
            EDtext "The 3rd button was pressed"

          Case 104
            TBtext "ID 104"
            SBtext 4,"Test 4"
            EDtext "The 4th button was pressed"

          Case 105
            TBtext "ID 105"
            SBtext 5,"Test 5"
            EDtext "OK, you pressed button 5"

          Case 106
            EDclear
            SBtext 1,0
            SBtext 2,0
            SBtext 3,0
            SBtext 4,0
            SBtext 5,0
            TBtext ADDR MainTitle

          Case IDCANCEL
            jmp quit_dialog
        Endsw

      Case WM_PAINT
        mov hDC, FUNC(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke GetWindowRect,hStatus,ADDR crct
        mov eax, crct.bottom
        sub eax, crct.top
        sub rct.bottom, eax
        invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
        invoke EndPaint,hWin,ADDR ps

      Case WM_CLOSE
        quit_dialog: 
        invoke EndDialog,hWin,0
    Endsw

    xor eax, eax
    ret

DlgProc endp

; 

end start
